#include "cdiff.h"
#include <immintrin.h>

int cdiff(const char* x, const char* y, int n) {
	int i, j, cnt = 0;
	unsigned char mcnt[16];
	__m128i xv, yv, res, vcnt, vone;
	vone = _mm_set_epi8(1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1);
	vcnt = _mm_set_epi8(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);
	
	for (i=0; i+15<n; i+=16) {
		if (i % 256 == 0) {
			_mm_store_si128((__m128i*)mcnt, vcnt);
			for (j=0; j<16; j++) cnt += mcnt[j];
			vcnt = _mm_set_epi8(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);		
		}
		xv = _mm_load_si128((__m128i const*)(x+i));
		yv = _mm_load_si128((__m128i const*)(y+i));
		res = _mm_cmpeq_epi8(xv, yv);
		res = _mm_add_epi8(res,vone);
		vcnt = _mm_add_epi8(vcnt,res);
	}

	for (; i<n; ++i)
		if (x[i] != y[i]) ++cnt;

	_mm_store_si128((__m128i*)mcnt, vcnt);
	
	for (j=0; j<16; j++) cnt += mcnt[j];

	return cnt;
}
